<template>
  <div>
    <goticket />
    <ticketnow />
    <h1 class="mt-5 mb-5 tc">
      <Icon type="md-train" />
      {{ $t('trainborard.traintimetable') }}
    </h1>
    <Form :label-width="90">
      <Row>
        <i-Col span="24">
          <RadioGroup type="button" v-model="btngroup">
            <Radio label="0">{{ $t('trainborard.bytime') }}</Radio>
            <Radio label="1">{{ $t('trainborard.bystation') }}</Radio>
            <Radio label="2">{{ $t('trainborard.bytrain') }}</Radio>
          </RadioGroup>
          <Card dis-hover class="mt-10 gray" v-if="btngroup==='0'">
            {{ $t('trainborard.date') }}：
            <selectdate @sendout="sendoutfordate" />
            {{ $t('trainborard.Arrivedfromthestation') }}：
            <selectarea @sendout="getstartarea" />
            <Icon type="md-swap" class="mr-5" />
            <selectarea @sendout="getendarea" />
            <Button
              type="primary"
              @click="train_time_board(godate,startarea,endarea)"
            >{{ $t('trainborard.search') }}</Button>
          </Card>
          <Card dis-hover class="mt-10 gray" v-if="btngroup==='1'">
            {{ $t('trainborard.date') }}：
            <selectdate @sendout="sendoutfordate" />
            {{ $t('trainborard.station') }}：
            <selectarea @sendout="getstartarea" />
            <Button
              type="primary"
              @click="traintimeboardfromstation(godate,startarea)"
            >{{ $t('trainborard.search') }}</Button>
          </Card>
          <Card dis-hover class="mt-10 gray" v-if="btngroup==='2'">
            {{ $t('trainborard.date') }}：
            <selectdate @sendout="sendoutfordate" />
            {{ $t('trainborard.Trips') }}：
            <Input
              search
              :placeholder="$t('trainborard.texttips')"
              style="width: auto"
              v-model="selctnote"
              @keyup.enter.native="trainnote(godate,selctnote)"
            />
            <Button
              type="primary"
              @click="trainnote(godate,selctnote)"
            >{{ $t('trainborard.search') }}</Button>
          </Card>
        </i-Col>
        <i-col span="24">
          <Spin fix v-if="$store.getters.getmodloading">
            <Icon type="ios-loading" size="18" class="demo-spin-icon-load"></Icon>
            <div>{{ $t('loading') }}</div>
          </Spin>
          <traintable v-if="btngroup === '0'" :tableboard="train_time" />
          <stationboard v-if="btngroup === '1'" :tableboard="trainstation" />
          <note v-if="btngroup === '2' " :tableboard="note" />
          <h5 class="mt-10">{{ $t('trainborard.footerword1') }}</h5>
          <h5 class="mb-10">{{ $t('trainborard.footerword2') }}</h5>
        </i-col>
        <Divider />
      </Row>
    </Form>
  </div>
</template>

<script>
import { mapMutations } from "vuex";
import goticket from "~/components/modalarea/ticket_modal.vue";
import traintable from "~/components/checkstation/trainboard.vue";
import stationboard from "~/components/checkstation/trainboardfromstation.vue";
import note from "~/components/checkstation/trainnote.vue";
import ticketnow from "~/components/modalarea/goticket.vue";
import selectdate from "~/components/tools/selectdate.vue";
import selectarea from "~/components/tools/selectstation.vue";
export default {
  components: {
    goticket,
    traintable,
    stationboard,
    note,
    ticketnow,
    selectdate,
    selectarea
  },
  data() {
    return {
      btngroup: "0",
      startarea: "",
      endarea: "",
      selctnote: "",
      godate: null,
      train_time: [],
      trainstation: [],
      note: []
    };
  },
  methods: {
    ...mapMutations({
      toggleloading: "toggleloading"
    }),
    sendoutfordate(childValue) {
      this.godate = childValue;
    },

    getstartarea(sendoutarea) {
      this.startarea = sendoutarea;
    },
    getendarea(sendoutarea) {
      this.endarea = sendoutarea;
    },

    async train_time_board(date, startarea, endarea) {
      this.toggleloading();
      if (date != null && startarea != "" && endarea != "") {
        if (startarea === endarea) {
          this.$Message.error(
            this.$t("trainborard.fun_train_time_board_Message")
          );
          this.toggleloading();
        } else {
          const train_time = await this.$axios.$get(
            `DailyTimetable/OD/${startarea}/to/${endarea}/${date}?$top=50&$format=JSON`
          );
          this.train_time = train_time;
          this.toggleloading();
          if (train_time.length == 0) {
            return this.$Message.warning(
              this.$t("trainborard.fun_train_time_board_Message_2")
            );
            this.toggleloading();
          }
        }
      } else {
        this.$Message.error(
          this.$t("trainborard.fun_train_time_board_Message_3")
        );
        this.toggleloading();
      }
    },
    async traintimeboardfromstation(date, area) {
      this.toggleloading();
      if (date == null || area == "") {
        this.$Message.error(
          this.$t("trainborard.fun_train_time_board_Message_3")
        );
        this.toggleloading();
      } else {
        const trainstation = await this.$axios.$get(
          `DailyTimetable/Station/${area}/${date}?$top=80&$format=JSON`
        );
        this.trainstation = trainstation;
        this.toggleloading();
      }
    },
    async trainnote(date, trainno) {
      this.toggleloading();
      if (date == null || trainno == "") {
        this.$Message.error(
          this.$t("trainborard.fun_train_time_board_Message_3")
        );
        this.toggleloading();
      } else {
        const trainnote = await this.$axios.$get(
          `DailyTimetable/TrainNo/${trainno}/TrainDate/${date}?$top=30&$format=JSON`
        );
        this.note = trainnote;
        this.toggleloading();
        if (trainnote.length == 0) {
          return this.$Message.warning(
            this.$t("trainborard.fun_train_time_board_Message_2")
          );
          this.toggleloading();
        }
      }
    }
  }
};
</script>
